LeetCode 刷题 [C++] 第300题.最长递增子序列

题目描述

给你一个整数数组 nums ,找到其中最长严格递增子序列的长度。

子序列 是由数组派生而来的序列,删除(或不删除)数组中的元素而不改变其余元素的顺序。例如,3,6,2,7 是数组 0,3,1,6,2,2,7 的子序列。

题目分析

当前题目可以直接使用动态规划来解决,不过时间复杂度为O(n^2),不满足进阶中的要求。

因此,可以使用贪心+二分查找来满足O(nlogn)的时间复杂度。

  1. 贪心思路:要让上升子序列上升的尽可能的慢,才能找到尽可能长的递增子序列。
  2. 实现方法
    • 维护一个辅助数组tmp,它的每一个元素tmpi 的含义是,所有长度为 i+1 的上升子序列的末尾元素中的最小值;
    • 使用seq_len表示辅助数组tmp当前的长度,并且在遍历输入数组时,需要维护辅助数组tmp的性质:
      • 如果遇到一个比tmp的尾部元素更大的值,说明形成了一个更长的上升序列,则把它追加到tmp的尾部,seq_len加1;
      • 如果遇到一个比tmp的尾部元素更小的值,说明发现了某个上升子序列的、更小的末尾元素,需要更新它。因为tmp是有序的,可以使用二分查找目标位置来更新,因此总时间复杂度是 O(nlogn)。
    • 最终seq_len就是最长递增子序列的长度。

Code

cpp 复制代码
class Solution {
public:
    int lengthOfLIS(vector<int>& nums) {
        int seq_len = 1, size = nums.size();
        if (0 == size) {
            return 0;
        }
        vector<int> tmp(size + 1, 0);
        tmp[seq_len] = nums[0];
        for (int i = 0; i < size; ++i) {
            if (nums[i] > tmp[seq_len]) {
                tmp[++seq_len] = nums[i];
            } else {
                int l = 1, r = seq_len, pos = 0;
                while (l <= r) {
                    int mid = (l + r) >> 1;
                    if (tmp[mid] < nums[i]) {
                        pos = mid;
                        l = mid + 1;
                    } else {
                        r = mid - 1;
                    }
                }
                tmp[pos + 1] = nums[i];
            }
        }
        return seq_len;
    }
};
相关推荐
Sakura_j_h_7 小时前
EasyEDA PCB 快速设计Skills
c++·python·github
ZhengEnCi7 小时前
Agent 架构怎么选:从单 Agent 到多 Agent 编排的选型决策指南
算法·架构
程序喵大人7 小时前
【C++入门】内存模型与资源管理 - 09 shared_ptr 和 weak_ptr 解决共享,也带来代价
开发语言·c++·资源管理·智能指针·内存模型
秋天的怀念_David8 小时前
第二十二夜 · 数字迷雾
java·程序人生·算法
Pniubi8 小时前
力扣283移动零(双指针法)
算法·leetcode·职场和发展
hhb_6188 小时前
大模型落地三重优化实战
人工智能·算法·机器学习
云和数据.ChenGuang8 小时前
光哥说Python RAG 系统需要哪些评估指标:从检索到生成的全链路评测指南
网络·人工智能·python·算法·langchain
jimy19 小时前
C++ 中的 `T&&`:右值引用与转发引用
开发语言·c++
2601_9707038310 小时前
工业除湿机租赁:把一份租金合同拆开看
大数据·数据结构·算法·数据库架构·推荐算法
心中有你021410 小时前
Java实现Dijkstra最短路径算法(邻接表 + 优先队列)
java·数据库·算法